package de.ozgcloud.apilib.demo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Component;

import de.ozgcloud.apilib.alfa.AlfaService;
import de.ozgcloud.apilib.file.OzgCloudFileService;
import de.ozgcloud.apilib.vorgang.OzgCloudVorgangId;
import de.ozgcloud.apilib.vorgang.OzgCloudVorgangService;

@Component
class DemoRunner implements ApplicationListener<ContextRefreshedEvent> {

	private static final OzgCloudVorgangId VORGANG_ID = OzgCloudVorgangId.from("64e889ba8e24a914a1628047");

	@Autowired
	private OzgCloudVorgangService vorgangService;
	@Autowired
	private OzgCloudFileService fileService;
	@Autowired
	private AlfaService alfaService;

	@Override
	public void onApplicationEvent(ContextRefreshedEvent event) {
		System.out.println(vorgangService.search("Deutschland"));

		System.out.println(vorgangService.getById(VORGANG_ID));

		alfaService.addAktenNotiz(VORGANG_ID, "Hello World!");
	}

}
